#include "huc.h"

#define TRACK_LEN	100
#define NUM_PARMS	18

char val[50];
char track;

const char *parm_name[] = {
"  Volume    = ",
"  Wave      = ",
"  Envelope  = ",
"  Octave    = ",
"  Detune    = ",
"  Timebase  = ",
"  Len Ratio = ",
"  Mode      = ",
"  FM ???    = ",
"  FM Delay  = ",
"  FM Adjust = ",
"  Pitch Env = ",
"  PE Delay  = ",
"  Sweep     = ",
"  Sw. Time  = ",
"  Transpose = ",
"  Rel Trans = ",
"  Full Tran = "
};

const int parm_min[] = {
0,
0,
0,
0,
-1,
0,
1,
0,
0,
0,
0,
0,
0,
-1,
0,
-1,
-1,
-1
};

const int parm_max[] = {
31,
44,
15,
7,
256,
31,
8,
2,
0x7F,
0x7F,
7,
0x7F,
0xFF,
256,
0xFF,
256,
256,
256
};


#asm

VOL_OFFSET	=	1
DETUNE_OFFSET	=	3
ENV_OFFSET	=	7
WAVE_OFFSET	=	9
LENRATIO_OFFSET	=	11
MODE_OFFSET	=	13
OCT_OFFSET	=	14
TIMEBASE_OFFSET	=	16
FMUNKN_OFFSET	=	22
FMDELAY_OFFSET	=	24
FMADJUST_OFFSET	=	26
PITCHENV_OFFSET	=	28
PEDELAY_OFFSET	=	30
SWEEP_OFFSET	=	32
SWPTIME_OFFSET	=	34
TRANSPOS_OFFSET	=	36
RELTRANS_OFFSET	=	38
FULTRANS_OFFSET	=	40

	.data

_psg_music:
	.db	LOW(_psg_heada)
	.db	HIGH(_psg_heada)+$20
	.db	LOW(_psg_headb)
	.db	HIGH(_psg_headb)+$20
	.db	LOW(_psg_headc)
	.db	HIGH(_psg_headc)+$20
	.db	LOW(_psg_headd)
	.db	HIGH(_psg_headd)+$20

_psg_heada:
	.db	$20			; voice 6
	.db	LOW(_psg_tracka)
	.db	HIGH(_psg_tracka)+$20
_psg_headb:
	.db	$01			; voice 1
	.db	LOW(_psg_tracka)
	.db	HIGH(_psg_tracka)+$20
_psg_headc:
	.db	$20			; dasenio test
	.db	LOW(_psg_trackb)
	.db	HIGH(_psg_trackb)+$20
_psg_headd:
	.db	$20			; senio test
	.db	LOW(_psg_trackc)
	.db	HIGH(_psg_trackc)+$20

_psg_tracka:
	.db	$DC, $1F	; volume
	.db	$EC, $00	; detune
	.db	$DD, $FF	; pan pot
	.db	$E6, $06	; set envelope
	.db	$E5, $04	; set wave
	.db	$DE, $01	; on/off ratio
	.db	$F8, $00	; mode
	.db	$D5		; set octave
	.db	$D0, $08	; set timebase
	.db	$16		; A half note
	.db	$26		; B half note
	.db	$36		; C half note
	.db	$46		; D half note
	.db	$E7, $00	; FM modulation ?
	.db	$E8, $00	; FM Delay
	.db	$E9, $00	; FM Adjust
	.db	$EA, $00	; Pitch Envelope
	.db	$EB, $00	; PE Delay
	.db	$ED, $00	; Sweep
	.db	$EE, $00	; Sweep Time
	.db	$F2, $00	; Transpose
	.db	$F3, $00	; Rel Trans
	.db	$F4, $00	; Full Trans
	.db	$16		; A half note
	.db	$26		; B half note
	.db	$36		; C half note
	.db	$46		; D half note
	.db	$FF		; end of data
	.db	$FF		; end of data
	.db	$FF		; end of data

_psg_trackb:
	.db	$E1		; "Da se ni yo"
	.db	$EF		; jump
	.db	LOW(_psg_tracka)
	.db	HIGH(_psg_tracka)+$20
	.db	$FF

_psg_trackc:
	.db	$E2		; "se ni yo"
	.db	$EF		; jump
	.db	LOW(_psg_tracka)
	.db	HIGH(_psg_tracka)+$20
	.db	$FF

	.code
#endasm


call_psg()
{
#asm

	lda	#PSG_INIT
	sta	<_dh
	stz	<_al
	jsr	psg_bios

	lda	#PSG_ON
	sta	<_dh
	stz	<_al
	jsr	psg_bios

	lda	#PSG_BANK
	sta	<_dh
	lda	#BANK(_psg_music)
	sta	<_al
	inc	A
	sta	<_ah
	jsr	psg_bios

	lda	#PSG_TRACK
	sta	<_dh
	lda	#LOW(_psg_music)
	sta	<_al
	lda	#HIGH(_psg_music)+$20
	sta	<_ah
	jsr	psg_bios

	lda	#PSG_PLAY
	sta	<_dh
	lda	_track
	sta	<_al
	stz	<_ah
	jsr	psg_bios

#endasm
}


get_values()
{
#asm
	.bss
_tempmmr:	.ds	1

	.code

	tma	#3
	sta	_tempmmr
	lda	#BANK(_psg_tracka)
	tam	#3

	lda	_psg_tracka+VOL_OFFSET		; volume
	sta	_val

	lda	_psg_tracka+WAVE_OFFSET		; wave
	sta	_val+1

	lda	_psg_tracka+ENV_OFFSET		; envelope
	sta	_val+2

	lda	_psg_tracka+OCT_OFFSET		; octave
	sub	#$D0
	sta	_val+3

	lda	_psg_tracka+DETUNE_OFFSET	; detune
	sta	_val+4

	lda	_psg_tracka+TIMEBASE_OFFSET	; timebase
	sta	_val+5

	lda	_psg_tracka+LENRATIO_OFFSET	; length ratio
	sta	_val+6

	lda	_psg_tracka+MODE_OFFSET		; mode
	sta	_val+7

	lda	_psg_tracka+FMUNKN_OFFSET	; FM ???
	sta	_val+8

	lda	_psg_tracka+FMDELAY_OFFSET	; FM Delay
	sta	_val+9

	lda	_psg_tracka+FMADJUST_OFFSET	; FM Adjust
	sta	_val+10

	lda	_psg_tracka+PITCHENV_OFFSET	; Pitch Env
	sta	_val+11

	lda	_psg_tracka+PEDELAY_OFFSET	; PE Delay
	sta	_val+12

	lda	_psg_tracka+SWEEP_OFFSET	; Sweep
	sta	_val+13

	lda	_psg_tracka+SWPTIME_OFFSET	; Sweep Time
	sta	_val+14

	lda	_psg_tracka+TRANSPOS_OFFSET	; Transpose
	sta	_val+15

	lda	_psg_tracka+RELTRANS_OFFSET	; Rel Trans
	sta	_val+16

	lda	_psg_tracka+FULTRANS_OFFSET	; Full Trans
	sta	_val+17

	lda	_tempmmr
	tam	#3
#endasm
}

set_values()
{
#asm
	tma	#3
	sta	_tempmmr
	lda	#BANK(_psg_tracka)
	tam	#3

	lda	_val		; volume
	sta	_psg_tracka+VOL_OFFSET

	lda	_val+1		; wave
	sta	_psg_tracka+WAVE_OFFSET

	lda	_val+2		; envelope
	sta	_psg_tracka+ENV_OFFSET

	lda	_val+3		; octave
	add	#$D0
	sta	_psg_tracka+OCT_OFFSET

	lda	_val+4		; detune
	sta	_psg_tracka+DETUNE_OFFSET

	lda	_val+5		; timebase
	sta	_psg_tracka+TIMEBASE_OFFSET

	lda	_val+6		; length ratio
	sta	_psg_tracka+LENRATIO_OFFSET

	lda	_val+7		; mode
	sta	_psg_tracka+MODE_OFFSET

	lda	_val+8		; FM ???
	sta	_psg_tracka+FMUNKN_OFFSET

	lda	_val+9		; FM Delay
	sta	_psg_tracka+FMDELAY_OFFSET

	lda	_val+10		; FM Adjust
	sta	_psg_tracka+FMADJUST_OFFSET

	lda	_val+11		; Pitch Env
	sta	_psg_tracka+PITCHENV_OFFSET

	lda	_val+12		; PE Delay
	sta	_psg_tracka+PEDELAY_OFFSET

	lda	_val+13		; Sweep
	sta	_psg_tracka+SWEEP_OFFSET

	lda	_val+14		; Sweep Time
	sta	_psg_tracka+SWPTIME_OFFSET

	lda	_val+15		; Transpose
	sta	_psg_tracka+TRANSPOS_OFFSET

	lda	_val+16		; Rel Trans
	sta	_psg_tracka+RELTRANS_OFFSET

	lda	_val+17		; Full Trans
	sta	_psg_tracka+FULTRANS_OFFSET

	lda	_tempmmr
	tam	#3
#endasm
}



main()
{
int i,j;

   set_color(0,0);
   set_color(1,511);

   i = 0;

   while (1)
   {
     get_values();
/*
     val[0] = vol
     val[1] = wave
     val[2] = env
     val[3] = octave
     val[4] = detune
     val[5] = timebase
     val[6] = length ratio
     val[7] = mode
     val[8] = FM ???
     val[9] = FM Delay
     val[10] = FM Adjust
     val[11] = Pitch Env
     val[12] = PE Delay
     val[13] = Sweep
     val[14] = Sweep Time
     val[15] = Transposition
     val[16] = Relative Transposition
     val[17] = Full Transposition
*/

     while (1)
     {

        for (j = 0; j < NUM_PARMS; j++)
        {
           put_string(parm_name[j], 3, 4+j);
           put_hex(val[j], 2, 16, 4+j);
        }

        put_string("o", 3, 4+i);


        put_string("Hit RUN to play", 7, NUM_PARMS+7); 

        while(joytrg(0) == 0);

        if (joy(0) & JOY_STRT)
        {
           set_values();
           break;
        }
        else if (joy(0) == JOY_UP)
        {
           if (i > 0) i--;
        }
        else if (joy(0) == JOY_DOWN)
        {
           if (i < NUM_PARMS-1) i++;
        }
        else if (joy(0) == JOY_LEFT)
        {
           if (val[i] > parm_min[i])
              val[i]--;
        }
        else if (joy(0) == JOY_RGHT)
        {
           if (val[i] < parm_max[i])
              val[i]++;
        }
        vsync(0);
     }
     
     track = 0;

     if (joy(0) & JOY_A)
        track |= 1;

     if (joy(0) & JOY_B)
        track |= 2;

     put_string("RUNNING...     ", 7, NUM_PARMS+7);
     call_psg();

     vsync(2);

   }

   return;
}

